// HCListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HCList.h"
#include "HCListDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHCListDlg dialog

CHCListDlg::CHCListDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHCListDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHCListDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHCListDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHCListDlg)
	DDX_Control(pDX, IDC_HCLIST, m_cHCList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHCListDlg, CDialog)
	//{{AFX_MSG_MAP(CHCListDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RESCAN, OnRescan)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHCListDlg message handlers

BOOL CHCListDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

    m_cHCList.InsertColumn(0, _T("Description"), LVCFMT_LEFT, 200);
    m_cHCList.InsertColumn(1, _T("Type"), LVCFMT_LEFT, 40);
    m_cHCList.InsertColumn(2, _T("Hardware ID"), LVCFMT_LEFT, 200);
    m_cHCList.InsertColumn(3, _T("Compatible ID"), LVCFMT_LEFT, 200);

    OnRescan();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHCListDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHCListDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

bool CHCListDlg::CheckUSBHCType(CString &szCompatibleIDs, CString &szClassCode)
{
    int foundAt = szCompatibleIDs.Find(szClassCode);
    if(foundAt >= 0)
    {
        return true;
    }
    return false;
}

void CHCListDlg::OnRescan() 
{
    m_diMgr.RebuildList();
    m_cHCList.DeleteAllItems();
    int nItems = 0;

    while(m_diMgr.Enum())
    {
        CString szDeviceName;
        m_diMgr.DeviceName(szDeviceName);
        TRACE("examining >%s<...\n", szDeviceName);

        CString szCompatibleIDs;
        if(m_diMgr.CompatibleIDs(szCompatibleIDs))
        {
            TRACE("  CompatibleIDs: >%s<\n", szCompatibleIDs);
            CString szLowerCaseCompatibleIDs(szCompatibleIDs);
            szLowerCaseCompatibleIDs.MakeLower();
            
            // look for the PCI class code and figure out type

#define TYPE_NONE -1
#define TYPE_UHCI 0
#define TYPE_OHCI 1
#define TYPE_EHCI 2
            
            int type = TYPE_NONE;
            LPCTSTR szType = NULL;
            CString szUHCI = _T("pci\\cc_0c0300");
            CString szOHCI = _T("pci\\cc_0c0310");
            CString szEHCI = _T("pci\\cc_0c0320");
            if(CheckUSBHCType(szLowerCaseCompatibleIDs, szUHCI))
            {
                // we have a UHCI controller
                type = TYPE_UHCI;
                szType = _T("UHCI");
            }
            else if(CheckUSBHCType(szLowerCaseCompatibleIDs, szOHCI))
            {
                // we have an OHCI controller
                type = TYPE_OHCI;
                szType = _T("OHCI");
            }
            else if(CheckUSBHCType(szLowerCaseCompatibleIDs, szEHCI))
            {
                // we have an EHCI controller
                type = TYPE_EHCI;
                szType = _T("EHCI");
            }
            else
            {
                // we're not dealing with any USB controller
            }

            if(TYPE_NONE != type)
            {
                CString szHardwareId;
                m_diMgr.HardwareID(szHardwareId);
                m_cHCList.InsertItem(nItems, szDeviceName);
                m_cHCList.SetItem(nItems, 1, LVIF_TEXT, szType, -1, -1, 0, NULL);
                m_cHCList.SetItem(nItems, 2, LVIF_TEXT, szHardwareId, -1, -1, 0, NULL);
                m_cHCList.SetItem(nItems, 3, LVIF_TEXT, szCompatibleIDs, -1, -1, 0, NULL);
                nItems++;
            }
        }
    }
}
